<?php

if( isset( $_REQUEST['debug'] )) header( "Content-type: text/plain; charset=utf-8" );

function toDebug()
{
	if( ! isset( $_REQUEST['debug'] )) return;

	$a = func_get_args();
	$s = '';
	foreach( $a as $v )
	 if( is_string( $v )) $s .= $v;
	 else $s .= var_export( $v, true );

	echo "\n$s\n";
}

class m3uList
{
	//
	// ----------------------------
	static function getExtInfo( $s, &$ret )
	{
#		toDebug("getExtInfo($s):");

		if( preg_match( '|^#EXT.*?:(\-?[\d]*) *(.*?)(,(.*))?$|', $s, $a ) > 0 )
		{
#			toDebug("first:", $a );

			if( isset( $a[4] )) $ret['title'   ] = trim( $a[4] );
			if( $a[1] != '')    $ret['duration'] = trim( $a[1] );

			if( strlen( $a[2] ) > 0
			&& preg_match_all( '#([\-\w\d]+)=(([\w\d\-\:]+)|("(.*?)"))#', $a[2], $a ) > 0 )
			{
#				toDebug("second:", $a );

				 foreach( $a[1] as $i => $id )
				  if( $a[3][$i] != '' ) $ret[ $id ] = $a[3][$i];
				  else  $ret[ $id ] = $a[5][$i];
			}
		}
	}
	//
	// ------------------------------------
	static function isUTF8( &$s )
	{
		// check BOM
		if( substr( $s, 0, 3) == "\xEF\xBB\xBF" )
		{
			$s = substr( $s, 3 );
			return true;
		}
		// check russian multibyte
		if( preg_match_all( '/(((\xd0[\x90-\xbf])|(\xd1[\x80-\x91]))+)/', $s, $ss ) > 0 )
		 foreach( $ss[0] as $a )
		  if( strlen( $a ) > 4 ) return true;

		return false;
	}
	//
	// ------------------------------------
	static function getListFromFile( $path )
	{
		toDebug("playlists::getList( $path )");

		$list = array();

		$s = @file_get_contents( $path );
		if( $s === false ) return $list;

		$s = str_replace( "\r", '', $s );

		if( ! self::isUTF8( $s ) ) $s = iconv('windows-1251', 'utf-8', $s);

		$ss = explode( "\n", $s );

		// parse playlist file
		$info  = array();
		$group = '';
		foreach( $ss as $s )
		{
			if(( $s = trim( $s )) == '') continue;
			if( strpos( $s, '?'          ) === 0 ) continue;
			if( strpos( $s, '#EXT-INETRA') === 0 ) { self::getExtInfo( $s, $info ); continue; }
			if( strpos( $s, '#EXTINF'    ) === 0 ) { self::getExtInfo( $s, $info ); continue; }
			if( strpos( $s, '#'          ) === 0 ) continue;

			$a = explode( '|', $s );
			if( count( $a ) > 1 )
			{
				$info['title'] = isset( $a[19] ) ? $a[19] : $a[15];
				$link = $a[0];
			}
			else $link = $s;

			$a = array(
				'link' => $link
			);
		
			$a['title'] = ( isset( $info['title'] )) ? $info['title'] : $s;

			if( isset( $info['cn-id'       ] )) $a['id'       ] = $info['cn-id'       ];
			if( isset( $info['territory-id'] )) $a['territory'] = $info['territory-id'];

			if( isset( $info['cn-records'] )
			&&  $info['cn-records'] == 1 ) $a['records'] = true;

			if( isset( $info['group-title'] )) $group = $info['group-title'];
			if( $group != '' ) $a['group'] = $group;

			$list[] = $a;

			$info = array();
		}

		toDebug("playlists::getList:", $list );

		return $list;
	}
}

?>
