<?php
/*
 *	iptvlist created by Roman Lut aka hax.
 *	
 *	Dionys edit
 *	©2014 Dionys, skiner@inbox.ru
*/

header('Content-Type:text/plain');
mb_internal_encoding('UTF-8'); 

//----------------------------------------------- PHP CUSTOM SETTINGS
set_time_limit(0);
error_reporting(E_ALL ^ E_NOTICE);
ini_set('logdbgs',		'On');
ini_set('error_log',	'epg.error.log');

//----------------------------------------------- DEPENDENCIES
ob_start('eecallback');
require_once 'iptvlist_timezone.php';
ob_end_flush();

ob_start('eecallback');
require_once 'iptvlist_common.php';
ob_end_flush();

ob_start('eecallback');
require_once 'parse_epg.php';
ob_end_flush();

//----------------------------------------------- CONSTANTS
if (!defined('EPG'))	define('EPG',	'/tmp/epg.txt');
if (!defined('EOS'))	define('EOS',	chr(0x0A));
if (!defined('ENT'))	define('ENT',	chr(0x0D). EOS);

//----------------------------------------------- MAIN
if(isset($_GET['listName']))
{
	if(isset($_GET['title']))
	{
		if(isset($_GET['link']))
		{
			$listName	= $_GET['listName'];	//list name, f.e. Favorites.m3u
			$title		= $_GET['title'];		//program title as displayed in in interface, f.e. 'Discovery Channel'
			$link		= $_GET['link'];		//unmodified progam link(without proxy), f.e. udp://@230.33.0.16:1234
			$prMatch	= loadEPGMatch();
			$ctime_arr	= getdate(time());
			$focusHour	= $ctime_arr['hours'];
			if ($focusHour < 5)
			{
				$focusHour += 24;
			}

			parseEPG();

			$epg_channels	= file_get_contents(CHANNELS);
			$epg_data		= file_get_contents(DATA);

			//script has to return lines separated with "\n":
			//1)Number of items in list
			//2)Item index to set focus on (selected by current time to point to current program)
			//3)channel name as requested
			//4)channel name returned (after matching)
			//5)current date
			//6)items itself
			//if there is no matching channel found, script has to return channels list and focusindex = -1
			
			$channels		= explode(EOS, $epg_channels);
			$channels_count	= count($channels);

			if (array_key_exists($title, $prMatch))
			{
				$title1 = str_replace(' ', '', $prMatch[$title]);  
			} 
			else
			{
				$title1 = str_replace(' ', '', $title);  
			}
			$title1 = mb_convert_case($title1, MB_CASE_LOWER, 'UTF-8');

			$found		= 0;
			$count		= 0;
			$focusIndex	= 0;
			$foundName	= '';

			if (isset($_GET['match'])== false)
			{
				for ($i = 0; ($i + 2) < $channels_count; $i += 3)
				{
					$title2 = str_replace(' ', '', $channels[$i]);
					$title2 = mb_convert_case($title2, MB_CASE_LOWER, 'UTF-8');

					if ($title1 == $title2)
					{
						$foundName		= $channels[$i];
						$found			= 1;
						$startData		= intval($channels[$i + 1]);
						$endData		= intval($channels[$i + 2]);
						$data			= substr($epg_data, $startData, $endData - $startData);
						$data1			= explode(EOS, $data);
						$data1_count	= count($data1);
						$passed12		= 0;

						for ($j = 0; ($j + 1) < $data1_count; $j += 2)
						{
							$prtime		= $data1[$j];
							$prtime1	= explode(':', $prtime);
							$prHour		= intval($prtime1[0]);
							$prMinute	= intval($prtime1[1]);

							if ($prHour > 12)
							{
								$passed12 = 1;
							}
	
							if (($prHour < 12)&& ($passed12 != 0))
							{
								$prHour += 24;
							}

							if ($prHour < $focusHour ||($prHour == $focusHour && $prMinute <= $ctime_arr['minutes']))
							{
								$focusIndex = $count;
							}

							$prname	= $data1[$j + 1];
							$prname	= str_replace(',', ' ', $prname);
							$res	.= $prtime . '    ' . $prname . EOS;
							$count ++; 
						}

						break;
					}
				}
			}

			//do not return more then 100 entries. rss can't display it.
			if (($found == 1)&& ($count > 100))
			{
				$resa = explode(EOS, $res);
				$deleteAfterIndex = $focusIndex + 50; 					
				if ($deleteAfterIndex > (count($resa) - 1))
				{
					$deleteAfterIndex = count($resa) - 1;
				}		

				$deleteBeforeIndex = $focusIndex - 50; 					
				if ($deleteBeforeIndex < 0)
				{
					$deleteBeforeIndex = 0;
				}		

				$focusIndex -= $deleteBeforeIndex;
				$count = 0;

				unset($res);
				$res = '';

				for ($i = $deleteBeforeIndex; $i <= $deleteAfterIndex; $i++)
				{
					$res .= $resa[$i] . EOS;
					$count ++;
				}
			}

			if ($found == 0)
			{
				unset($res);

				$focusIndex = -1; 

				for ($i = 0; ($i + 2) < $channels_count; $i += 3)
				{
					$title2 = str_replace(',', ' ', $channels[$i]);
					$res[$count] .= $title2;
					$count ++;
				}

				uasort($res, 'utf_8_sort::cmp'); 

				$firstChar = mb_substr($title, 0, 1);

				$i = 0;
				foreach ($res as $title2)
				{
					$firstChar2 = mb_substr($title2, 0, 1);
					if ($firstChar2 == $firstChar)
					{
						$focusIndex = -1 - $i;	
						break;
					}

					if ($firstChar2 < $firstChar)
					{
						$focusIndex = -1 - $i;	
					}

					$i++;
				}

				$res = implode(EOS, $res);
			}

			file_put_contents(EPG, $count . EOS . $focusIndex . EOS . $title . EOS . $foundName . EOS . date('D M j H:i') . EOS . $res);

			echo EPG;
		}
		else
		{
			// link not specified
			return NULL;
        }
	}
	else
	{
		// title not specified
		return NULL;
	}
}
else
{
	// listName not specified
	return NULL;
}

//----------------------------------------------- FUNCTIONS
function eecallback($buffer)
{
  return '';
}
?>